import greenfoot.*;
import java.awt.Color;
public class AlphaOverlay extends Actor
{
    private static final double radius = 250;
    
    public AlphaOverlay() {
        GreenfootImage img = new GreenfootImage(MCWorld.WIDTH, MCWorld.HEIGHT);
        setImage(img);
    }
    
    public void act() {
        GreenfootImage img = getImage();
        img.clear();
        if(Greenfoot.isKeyDown("r")) return;
        int pX = MCWorld.PLAYER.getX();
        int pY = MCWorld.PLAYER.getY();
        for(int x = 0; x < MCWorld.BLOCK_WIDTH; x++)
        for(int y = 0; y < MCWorld.BLOCK_HEIGHT; y++) {
            if(MCWorld.BLOCKS[MCWorld.X_OFFSET + x][MCWorld.Y_OFFSET + y] == null) continue;
            int xReal = MCWorld.toReal(x);
            int yReal = MCWorld.toReal(y);
            int distToPlayer = (int)(Math.hypot(pX - xReal, pY - yReal) + 0.5);
            int alpha = Math.min(255, (int)(255*distToPlayer/radius + 0.5));
            if(alpha == 255) {
                img.setColor(Color.BLACK);
            } else {
                img.setColor(new Color(0, 0, 0, alpha));
            }
            img.fillRect(Block.SIZE*x, Block.SIZE*y, Block.SIZE, Block.SIZE);
        }
    }
}
