import greenfoot.*;
import java.awt.Color;
public class BackPanel extends Actor
{
    private GreenfootImage baseImg;
    private static final double radius = 500;
    
    public BackPanel() {
        makeBaseImg();
    }
    
    public void act() {
        GreenfootImage img = new GreenfootImage(baseImg);
        int pX = MCWorld.PLAYER.getX();
        int pY = MCWorld.PLAYER.getY();
        for(int x = 0; x < MCWorld.BLOCK_WIDTH; x++)
        for(int y = 0; y < MCWorld.BLOCK_HEIGHT; y++) {
            if(MCWorld.BLOCKS[MCWorld.X_OFFSET + x][MCWorld.Y_OFFSET + y] != null) continue;
            int xReal = MCWorld.toReal(x);
            int yReal = MCWorld.toReal(y);
            int distToPlayer = (int)(Math.hypot(pX - xReal, pY - yReal) + 0.5);
            int alpha = (int)(255*Math.min(1, distToPlayer/radius) + 0.5);
            img.setColor(new Color(0, 0, 0, alpha));
            img.fillRect(Block.SIZE*x, Block.SIZE*y, Block.SIZE, Block.SIZE);
        }
        setImage(img);
    }
    
    public void makeBaseImg() {
        baseImg = new GreenfootImage(MCWorld.WIDTH, MCWorld.HEIGHT);
        GreenfootImage skyBack = new GreenfootImage("SkyBack.png");
        GreenfootImage dirtBack = new GreenfootImage("DirtBack.png");
        GreenfootImage stoneBack = new GreenfootImage("StoneBack.png");
        for(int x = 0; x < MCWorld.BLOCK_WIDTH; x++)
        for(int y = MCWorld.Y_OFFSET; y < MCWorld.Y_OFFSET + MCWorld.BLOCK_HEIGHT; y++) {
            int xReal = Block.SIZE*x;
            int yReal = Block.SIZE*(y - MCWorld.Y_OFFSET);
            if(y < 14) {
                baseImg.drawImage(skyBack, xReal, yReal);
            } else if (y < 20) {
                baseImg.drawImage(dirtBack, xReal, yReal);
            } else {
                baseImg.drawImage(stoneBack, xReal, yReal);
            }
        }
    }
}
