import greenfoot.*;
import java.awt.Color;
public class Player extends Actor
{
    private boolean jumping = false;
    private int jumpTime = 0;
    private double vSpeed = 0.0;
    private int hSpeed = 2;
    private boolean keyDown = false;
    private static final double GRAVITY = 0.6;
    private static final double MAX_V_SPEED = 10;
    private static final int SIZE = 16;
    private static final int HALF_SIZE = SIZE/2;
    private static final int MAX_X = MCWorld.WIDTH - Block.HALF_SIZE - 1;

    public void act() {
        if(Greenfoot.isKeyDown("d")) {
            if(getX() >= MAX_X) {
                ((MCWorld)getWorld()).scrollRight();
            }
            if(getX() < MAX_X) {
                int rightX =  MCWorld.X_OFFSET + (getX() + hSpeed + HALF_SIZE)/Block.SIZE;
                int topY =    MCWorld.Y_OFFSET + (getY() - HALF_SIZE)/Block.SIZE;
                int bottomY = MCWorld.Y_OFFSET + (getY() + HALF_SIZE - 1)/Block.SIZE;
                Block b = MCWorld.BLOCKS[rightX][topY];
                if(b == null) {
                    b = MCWorld.BLOCKS[rightX][bottomY];
                    if(b == null) {
                        setLocation(getX() + hSpeed, getY());
                    }
                } else {
                    setLocation(b.getX() - Block.HALF_SIZE - HALF_SIZE, getY());
                }
            }
        }
        if(Greenfoot.isKeyDown("a")) {
            if(getX() <= Block.HALF_SIZE) {
                ((MCWorld)getWorld()).scrollLeft();
            }
            if(getX() > Block.HALF_SIZE) {
                int leftX =   MCWorld.X_OFFSET + (getX() - hSpeed - HALF_SIZE)/Block.SIZE;
                int topY =    MCWorld.Y_OFFSET + (getY() - HALF_SIZE)/Block.SIZE;
                int bottomY = MCWorld.Y_OFFSET + (getY() + HALF_SIZE - 1)/Block.SIZE;
                Block b = MCWorld.BLOCKS[leftX][topY];
                if(b == null) {
                    b = MCWorld.BLOCKS[leftX][bottomY];
                    if(b == null) {
                        setLocation(getX() - hSpeed, getY());
                    }
                } else {
                    setLocation(b.getX() + Block.HALF_SIZE + HALF_SIZE, getY());
                }
            }
        }
        
        
        
        
        if(getY() >= MCWorld.HEIGHT - Block.SIZE/2 - 1) {
            ((MCWorld)getWorld()).scrollDown();
        }
        /*
        Block inter = (Block)getOneIntersectingObject(Block.class);
        if(inter == null) {
            setLocation(getX(), getY() + 2);
            if(getOneIntersectingObject(Block.class) != null) {
                setLocation(getX(), getY() - 2);
                if(!jumping) {
                    if(Greenfoot.isKeyDown("space")
                    || Greenfoot.isKeyDown("w")) {
                        jumping = true;
                        jumpTime = 0;
                    }
                }
            }
        }*/
        int leftX =   MCWorld.X_OFFSET + (getX() - HALF_SIZE)/Block.SIZE;
        int rightX =  MCWorld.X_OFFSET + (getX() + HALF_SIZE - 1)/Block.SIZE;
        int bottomY = MCWorld.Y_OFFSET + (getY() + (int)(vSpeed + 0.5) + HALF_SIZE)/Block.SIZE;
        Block restingOn = MCWorld.BLOCKS[leftX][bottomY];
        if(restingOn == null) restingOn = MCWorld.BLOCKS[rightX][bottomY];
        
        boolean wasJumping = jumping;
        jumping = restingOn == null;
        if(!jumping) {
            if(wasJumping) {
                setLocation(getX(), restingOn.getY() - Block.HALF_SIZE - HALF_SIZE);
                vSpeed = 0;
            }
            if(Greenfoot.isKeyDown("space")
            || Greenfoot.isKeyDown("w")) {
                if(!keyDown) {
                    // Jump.
                    vSpeed = -8;
                    jumping = true;
                    keyDown = true;
                }
            }
        }
        if(jumping) {
            vSpeed = Math.min(MAX_V_SPEED, vSpeed + GRAVITY);
            int vChange = (int)(vSpeed + 0.5);
            setLocation(getX(), getY() + vChange);
            if(vChange < 0) { // Going upwards
                int topY = MCWorld.Y_OFFSET + (getY() - HALF_SIZE - 1)/Block.SIZE;
                Block hitAbove = MCWorld.BLOCKS[leftX][topY];
                if(hitAbove == null) hitAbove = MCWorld.BLOCKS[rightX][topY];
                if(hitAbove != null) {
                    vSpeed = -vSpeed;
                    setLocation(getX(), hitAbove.getY() + Block.HALF_SIZE + HALF_SIZE);
                }
            }
            if(vChange > 0) { // Going down
                
            }
        }
        if(keyDown
        && !(Greenfoot.isKeyDown("space")
          || Greenfoot.isKeyDown("w"))) {
            keyDown = false;
        }
        /*
        if(jumping) {
            jumpTime++;
            Block inter = (Block)getOneIntersectingObject(Block.class);
            if(inter != null || jumpTime >= 15) jumping = false;
            else if(inter == null) {
                setLocation(getX(), getY() - 4);
                if(getOneIntersectingObject(Block.class) != null) setLocation(getX(), getY() + 4);
            }
        }*/
    }
}











